#include <bits/stdc++.h>

using namespace std;

stack<int> s;

int brneg[999999];
int brpoz[999999];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n,k,a,br=0,za0=0;

    cin >> n;
    cin >> k;

    for(int i=0; i<n; i++)
    {
        cin >> a;

        if(a<0)
        {
            brneg[abs(a)-1]++;

            if(brneg[abs(a)-1]>=k)
            {
                s.push(a);
                br++;
                brneg[abs(a)-1]=-n;
            }
        }
        else if(a>0)
        {
            brpoz[a-1]++;

            if(brpoz[a-1]>=k)
            {
                s.push(a);
                br++;
                brpoz[a-1]=-n;
            }
        }
        else
        {
            za0++;

            if(za0>=k)
            {
                s.push(a);
                br++;
                za0=-n;
            }
        }
    }

    cout << br << endl;

    for(int i=br; i>0; i--)
    {
        cout << s.top() << " ";
        s.pop();
    }

    return 0;
}